package com.terraformersmc.terraform.mixin;

import com.terraformersmc.terraform.biomeapi.OverworldBiomesExt;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

import java.util.Optional;
import java.util.function.IntConsumer;
import net.minecraft.class_1959;
import net.minecraft.class_2378;
import net.minecraft.class_3630;
import net.minecraft.class_3641;

@Mixin(class_3641.class)
@SuppressWarnings("unused") // it's a mixin
public class MixinEaseBiomeEdgeLayer {
	@Inject(method = "sample", at = @At("HEAD"), cancellable = true)
	public void onSample(class_3630 rand, int neighbor1, int neighbor2, int neighbor3, int neighbor4, int center, CallbackInfoReturnable<Integer> info) {
		boolean replaced =
			tryReplace(center, neighbor1, info::setReturnValue) ||
				tryReplace(center, neighbor2, info::setReturnValue) ||
				tryReplace(center, neighbor3, info::setReturnValue) ||
				tryReplace(center, neighbor4, info::setReturnValue);

		if (replaced) {
			return;
		}

		if (surrounded(neighbor1, neighbor2, neighbor3, neighbor4, center)) {
			Optional<class_1959> target = OverworldBiomesExt.getCenter(class_2378.field_11153.method_10200(center));

			target.ifPresent(value -> info.setReturnValue(class_2378.field_11153.method_10249(value)));
		}
	}

	private static boolean tryReplace(int center, int neighbor, IntConsumer consumer) {
		if (center == neighbor) {
			return false;
		}

		Optional<class_1959> border = OverworldBiomesExt.getBorder(class_2378.field_11153.method_10200(neighbor));
		if (border.isPresent()) {
			consumer.accept(class_2378.field_11153.method_10249(border.get()));

			return true;
		}

		return false;
	}

	private static boolean surrounded(int neighbor1, int neighbor2, int neighbor3, int neighbor4, int biome) {
		return neighbor1 == biome && neighbor2 == biome && neighbor3 == biome && neighbor4 == biome;
	}
}
